!!
=======================================================================================
 Description ...: Form Generator
 Requirement(s).: RFO BASIC!
 Author ........: Giovanni Rossati (El Condor)
 Version........: 0.2.2
 Date...........: 30 October 2017
 License........: Free to use without any warranties
=======================================================================================
!!
include fgenViews.bas
FN.DEF fgen(parms$)	% returns string array dimension
goto skipError
	onError:
		gr.front 0
		PRINT GETERROR$()
		end
skipError:
	debug.on
!	debug.echo.on
	bundle.create GLOBAL % has to be at the top of the program, has ID of 1 (thanks evolbug)
	bundle.create fh_data	% for return data
	bundle.put 1, "fh_data", fh_data  	% the global fh_data
	bundle.create fieldsHandler	% fieldName -> handle
	bundle.put 1, "fieldsHandler", fieldsHandler
	bundle.create defaults	% fieldName --> value
	bundle.put 1, "defaults", defaults
	bundle.create fields	% fieldName --> index array
	bundle.create touchs	% key = fieldname, value handle, left, top, right, bottom
	bundle.put 1, "touchs", touchs  	% the global touchs
	bundle.create checks	% key = fieldname, control
	bundle.put 1, "checks", checks  	% the global controls
	bundle.create listValues	% For Radio buttons and Combo box (spinner) values
	bundle.put 1, "listValues",listValues
	bundle.create RDB	% For Radio buttons
	bundle.put 1, "RDB",RDB
	bundle.create After	% view after
	bundle.put 1, "After",After
% aligns constants ************************************************
	alignsLeft = 1
	alignsCenter = 2
	alignsRight = 3	
	bundle.create colors
	array.load a$[],"red","255 255 0 0","green","255 0 255 0","blue","255 0 0 255","olive","255 128 128 0","silver","255 192 192 192", ~
					"gray","255 128 128 128","grey","255 128 128 128","black","255 0 0 0","white","255 255 255 255","twhite","200 255 255 255"
	loadBundle(colors,a$[])
	bundle.put 1, "colors", colors  	% the global colors
	array.load aColors[],0,0,0,0,0
	bundle.create defaultLength
	array.load a$[],"RDB","10","N","8","T","20","CMT","16","CMB","16","PSW","16"
	loadBundle(defaultLength,a$[])
! buttons
	btnType = 0		% 0 no buttons 1 Ok button 2 Cancel button 4 reset button
	bundle.create buttons
	bundle.put buttons,"Ok","Ok"
	bundle.put buttons,"Cancel","Cancel"
	bundle.put buttons,"Reset","Reset"
	sw_exit = 0		% exit flag
	Screen.size, sSize[]
	screenW = sSize[1]
	screenH = sSize[2]
! Custom values	*****************************************************************
	offsetX = 0.05 * screenW
	offsetY = 100	% distance of text from the top
	btnWidth = 80	% button width
	deltaY = 70		% distance from views
	heightView = deltaY - 18		% distance from views
	charCheck$ = chr$(10004)	% check box character
	tPause = 400	% pause change color
	title$ = "RFO Basic Form Generator"
	bgColor$ = "silver"		% background form color
	titleColor$ = "black"	% title color
	titleBgColor$ = ""		% background title color, default is background form color 
	rdbOn$ =  CHR$(9673)
	rdbOff$ = CHR$(9711)
	fontSize = 24
	loadBundleList(1,"rdbOn," + rdbOn$ + ",rdbOff," + rdbOff$ +",fontSize,"+STR$(fontSize))
	gr.open aColors[1],aColors[2],aColors[3],aColors[4],,1	% orientation 1 portrait
	gr.text.size fontSize
	Gr.get.textbounds "EeeeAaSsIimw09", left, top, right, bottom
	charHeight = -top
	btnOffset = 0	% for btn show pression
	wideLabels = 0	% dimension of maximum label
	totalLabels = 0
	totalCharLabels = 0
	SPLIT widgets$[], parms$, ";\s*"
	length = count(widgets$[])
	list.create S, elem
	bundle.KEYS fh_data,list
	FOR i = 1 TO length
		SPLIT.ALL field$[], widgets$[i] + ",,,,", ","
		lengthParms = count(field$[])
		field$[1] = UPPER$(field$[1])
		type$ = field$[1]
		if mid$(widgets$[i],1,1) = "%" Then F_N.continue
		if is_in ("*" + type$ + "*","*T*P*N*U*CKB*CMB*CMT*RDB*") Then
			if field$[3] = "" Then field$[3] = field$[2]	% default label
			field$[3] = deMask$(field$[3])
			if field$[4] = "" Then field$[4] = getDefaultBundle$(defaultLength,type$,"20")	% default length
			JOIN.all field$[], w$, ","
			list.add elem,w$
			Gr.get.textbounds field$[3], left, top, right, bottom
			if wideLabels < right Then wideLabels = right
			totalLabels += right
			totalCharLabels += len(field$[3])
		elseif type$ = "TITLE" then
			title$ = field$[2]
			If field$[3] <> "" Then titleColor$ = field$[3]
			If field$[4] <> "" Then titleBgColor$ = field$[4]
		elseif type$ = "GROUND" | type$ = "BACKGROUND" Then			
			If field$[2] <> "" Then bgColor$ = field$[2]
			if titleBgColor$ = "" then titleBgColor$ = bgColor$
			if LOWER$(field$[3]) = "landscape" Then gr.orientation 0	% landscape
		elseif type$ = "AFTER" Then
			bundle.put After,field$[3],field$[2]		
		elseif LEFT$(type$,7) = "DEFAULT" then
			For j=2 To count(field$[])
				if field$[j] <> "" then
					bundle.put defaults,word$(field$[j],1,":"),deMask$(word$(field$[j],2,":"))
				endif
			next j
		elseif LEFT$(type$,5) = "CHECK" then
			join field$[],chk$,","
			bundle.put checks,field$[2], chk$	% the checks start at third item!
		elseif type$ = "B" then
			bundle.contain buttons,field$[2],contains
			If contains > 0 Then bundle.put buttons,field$[2],deMask$(field$[3])		% user caption
		endif
	NEXT i
	charWidth = totalLabels / totalCharLabels	% medium char length
	bundle.put 1,"charWidth",charWidth
	list.size elem, nElem
	List.toArray elem, widgets$[]
	decodeColor(bgColor$+",f",aColors[])	% fill
	setColor(bgColor$ + ",SF")
	gr.rect xx,0,0,screenW,screenH		% form background
	! Title ******************************************
	gr.text.size fontSize * 1.5	% title font size
	! background title
	setColor(titleBgColor$ + ",SF")	% stroke and fill
!	gr.rect xx,0,0,screenW,charHeight * 3		% form background 2 * 1.5
	fh_title = editText(title$,screenW/2,35,alignsCenter,titleColor$)
	offsetField = 5 + offsetX + wideLabels
	bundle.put 1,"offsetField", offsetField
	For i = 1 to nElem
		realDeltaY = deltaY
		SPLIT.ALL field$[],widgets$[i], ","
		ARRAY.LENGTH lengthParms, field$[]
		gr.text.size fontSize
		after$ = getDefaultBundle$(After,field$[2],"")
		if after$ <> "" then field$[3] = ""	% if view is after rease the label
		if trim$(field$[3]) <> "" Then lb = editText(field$[3] + ":",offsetX + wideLabels-10,offsetY,alignsRight,"twhite,fs")
		type$ = field$[1]
		top = offsetY - 35	% the top of box containing the text
		sw.begin type$
			sw.case "T","P","N","U","CMB","CMT"
				w = 5 + charWidth * VAL(field$[4])	% after view for buttons etc.
				lft = offsetField
				bundle.put fields,field$[2],i	% point to array of views
				If type$ <> "U" Then 	% not Unnmodifiable text
					bx = box(lft,top,w,heightView,"twhite,FS")
					if type$ <> "CMB" Then addTouch(touchs,field$[2],bx)
				endif
				alignement = alignsLeft
				if type$ = "N" Then 
					txt = editText("",offsetField + charWidth * VAL(field$[4]),offsetY,alignsRight,"black")				
				else
					txt = editText("",offsetField,offsetY,alignsLeft,"black")
				endif
				bundle.put fieldsHandler,field$[2],txt
				if is_in ("*" + type$ + "*","*CMB*CMT*") Then				% spinner (combo box)
					bundle.put fieldsHandler,"fh_"+field$[2],txt
					setListValues(listValues,field$[])	% extracts values
					lft = offsetField+w
					bx = box(lft,top,50,heightView,"twhite,FS")
					gr.text.size fontSize * 2
					editText(CHR$(9660),lft+20,offsetY+10,alignsCenter,"grey")
					addTouch(touchs,"fh_"+field$[2],bx)
					bundle.put fields,"fh_"+field$[2],i	% point to array of views
				endif
				sw.break
			sw.case "RDB"
				bundle.put fieldsHandler,field$[2],txt
				setListValues(listValues,field$[])	% extracts values
				deltaRDB = VAL(field$[4])*charWidth
				rdbHandlers$ = ""	% list of radio buttons handlers
				For j=5 To count(field$[])
					if field$[j] <> "" then
						label$ = WORD$(field$[j]+":"+field$[j], 2,":")
						key$ = WORD$(field$[j]+":"+field$[j], 1,":")
						gr.text.size fontSize * 2
						offsetRDB = 8+offsetField+deltaRDB*(j-5)
						bx = editText("",offsetRDB,offsetY+10,alignsCenter,"silver")
						gr.text.size fontSize
						editText(label$,30+offsetRDB,offsetY,alignsLeft,"twhite,fs")
						bundle.put touchs,field$[2]+key$,USING$("","%d,%d,%d,%d,%d,%s",INT(bx),INT(offsetRDB-20),INT(offsetY-25),INT(offsetRDB+charWidth*5-5),INT(offsetY+deltaY-35),field$[2])
						bundle.put fields,field$[2]+key$,i	% point to array of views
						bundle.put fieldsHandler,field$[2]+key$,bx
						rdbHandlers$ = USING$("","%s,%d",rdbHandlers$,INT(bx))
					Endif
				Next
				bundle.put RDB,field$[2], MID$(rdbHandlers$, 2)
				sw.break
			sw.case "CKB"
				bundle.put fh_data,field$[2],"Off"				
				lft = offsetField
				after$ = getDefaultBundle$(After,field$[2],"")
				if after$ <> "" then
					BUNDLE.GET touchs, after$, value$		% get fieldname and touch area
					SPLIT a$[], value$, ","
					gr.get.value VAL(A$[1]),"right",right
					gr.get.value VAL(A$[1]),"top",top
					lft = right+5
					realDeltaY = 0
				Endif
				bx = box(lft,top,heightView,heightView,"twhite,FS")
				addTouch(touchs,field$[2],bx)
				txt = editText("",lft+0.4*heightView,top+35,alignsCenter,"black")
				bundle.put fieldsHandler,field$[2],txt
				editText(field$[5],lft+heightView+8,top+35,alignsLeft,"twhite,FS")	% extra field
				bundle.put fields,field$[2],i	% point to array of views
				sw.break
			sw.case "BL"
				For j=5 To count(field$[])
					if field$[j] <> "" then
						key$ = word$(field$[j],2,":")
						if key$ = "" Then key$ = word$(field$[j],1,":")
						bundle.put listValues,field$[2] + key$,word$(field$[j],1,":")					
					endif
				Next
				sw.break
			sw.default
				print "Unknown field:",field$[2]
		sw.end
		offsetY = offsetY + realDeltaY
	NEXT i
!	buttons **********************
	BUNDLE.KEYS buttons, list
	LIST.SIZE list, size
	strtBtn = 0.5 * (screenW - size*(btnWidth)-(size-1)*2)
	btnOffset = offsetY-20		% attention this must be equal to third value on touchs !
	setColor("black")
	FOR i = 1 TO size
		LIST.GET list, i, key$
		GR.color 200,255,255,255,1
		BUNDLE.GET buttons, key$, value$
		btn = button(value$,strtBtn,btnOffset,btnWidth,deltaY-10)
		addTouch(touchs,"fh_"+key$,btn)
		strtBtn = strtBtn + btnWidth + 2
	NEXT i		
	setDefaults(widgets$[])	% gr.render is in function
	getText:
	do
	   gr.touch touched, x, y
	until touched
	bundle.get 1, "fh_data", fh_data
	BUNDLE.KEYS touchs, list
	LIST.SIZE list, size
!	check touches
% gr.bounded.touch touched, left, top, right, bottom
	FOR i = 1 TO size 
		LIST.GET list, i, key$
		BUNDLE.GET touchs, key$, value$		% get fieldname and touch area
		SPLIT a$[], value$, ","
		if (x > VAL(a$[2])) & (x < VAL(a$[4])) &  (y > VAL(a$[3])) & (y < VAL(a$[5])) Then
			if btnOffset = VAL(a$[3]) Then changeColor(VAL(a$[1]),"gray","twhite",tPause)	% buttons
			If key$ = "fh_Ok" Then
				sw_exit = checkData()
				bundle.put fh_data,"fh_button","Ok"
			elseIf key$ = "fh_Cancel" Then
				bundle.clear fh_data
				bundle.put fh_data,"fh_button","Cancel"
				sw_exit = 1
			elseIf key$ = "fh_Reset" Then
				setDefaults(widgets$[])
			Else 
				bundle.get fields,key$,indxView	% point to array of views
				type$ = word$(widgets$[indxView],1,",")
				bundle.contain fieldsHandler,key$, j
				if j > 0 Then bundle.get fieldsHandler,key$,hText
				if type$ = "CMT" Then 
					If LEFT$(key$,3)<> "fh_" Then type$ = "T"	% the choice is on spinner text
				EndIf
				sw.begin type$
					sw.case "CMB","CMT"		% spinner (combo box)
						BUNDLE.KEYS listValues, lst
						LIST.SIZE lst, sizeList
						LIST.CREATE S,spinner		% list of items to show
						Field$ = MID$(key$,4)
						FOR j = 1 TO sizeList
							LIST.GET lst, j, key$
							if LEFT$(key$,LEN(Field$)) = Field$ Then LIST.ADD spinner,MID$(Key$,LEN(Field$)+1)
						NEXT j
						gr.front 0
						List.toArray spinner, aSpinner$[]
						array.sort aSpinner$[]
						Select indx, aSpinner$[] ,Field$,"Please choice"
						gr.front 1
						If indx > 0 Then
							bundle.get listValues, Field$+aSpinner$[indx], value$
							bundle.put fh_data,Field$,value$
							gr.modify hText, "text", aSpinner$[indx]
						Endif
						sw.break
					sw.case "CKB"
						changeColor(VAL(a$[1]),"gray","twhite",tPause*0.5)
						bundle.get fh_data,key$,txt$
						bundle.get fieldsHandler,key$, hText
						setColor("black")
						if txt$ = "On" Then 
							bundle.put fh_data,key$,"Off"
							gr.modify hText, "text", ""
						else
							gr.modify hText, "text", charCheck$
							bundle.put fh_data,key$,"On"
						endif
						sw.break
					sw.case "RDB"
						% remove buttons check and set
						changeColor(VAL(a$[1]),"gray","twhite",tPause*0.5)
						bundle.get 1,"RDB",RDB
						bundle.get RDB,a$[6],rdbHandlers$	% radio button name
						Split h$[],rdbHandlers$,","
						bundle.get 1,"rdbOff",rdbOff$
						bundle.get fieldsHandler,key$,txt
						For j = 1 to count(h$[])
							gr.modify VAL(h$[j]),"text",rdbOff$
						Next
						bundle.get 1,"rdbOn",rdbOn$
						bundle.get fieldsHandler,key$,txt
						gr.modify txt,"text",rdbOn$
						bundle.put fh_data,a$[6],MID$(key$,LEN(a$[6])+1)
						sw.break
					sw.default
						gr.front 0
						bundle.get fh_data,key$,oldValue$
						if type$ = "N" Then		% numeric field
							input key$ + ": " + word$(widgets$[indxView],5,","), number,Val(oldValue$), cancel
							if cancel = 0 Then txt$ = STR$(number)
							GR.TEXT.ALIGN 3	% alignsRight
						else
							input key$ + ": " + word$(widgets$[indxView],5,","), txt$,oldValue$, cancel
							GR.TEXT.ALIGN 1		% alignsLeft
						Endif
						if cancel = 0 then 
							setColor("black")
							gr.modify hText, "text", txt$
							if type$ = "P" Then
								t$ = "**********"
								for j = 10 to LEN(txt$)
									t$ = t$ + "*"
								Next
								gr.modify hText, "text", LEFT$(t$,LEN(txt$))
							endif
!							GR.PAINT.GET the_paint
!							GR.MODIFY hText, "paint", the_paint
							bundle.put fh_data,key$,txt$	% save data
						endif
						gr.front 1
				sw.end
				gr.render
			endif
		endif
	NEXT i
	If sw_exit = 1 Then
		gr.front 0
		bundle.KEYS fh_data,list
		LIST.SIZE list, size
		FN.RTN fh_data
	Endif		
goto getText
FN.END
FN.DEF setDefaults(wdg$[])
	ARRAY.LENGTH n,wdg$[]
	bundle.get 1, "fh_data",fh_data
	bundle.get 1, "listValues",listValues
	bundle.get 1, "fieldsHandler",fieldsHandler
	bundle.get 1, "defaults",defaults
	bundle.get 1,"charWidth",charWidth
	bundle.get 1,"fontSize",fontSize$
	For i = 1 to n
		elem$ = wdg$[i]
		type$ = WORD$(elem$,1,",")
		fldName$ = WORD$(elem$,2,",")
		bundle.get fieldsHandler,fldName$,hText
		Bundle.contain defaults,fldName$,pntr	% search default
		GR.TEXT.ALIGN 1		% aligne left
		setValue$ = ""
		if pntr > 0 Then bundle.get defaults,fldName$,setValue$
		if type$ = "RDB" then
			bundle.get 1,"RDB",RDB
			bundle.get RDB,fldName$,rdbHandlers$
			Split h$[],rdbHandlers$,","
			bundle.get 1,"rdbOff",rdbOff$
			gr.text.size 2 * VAL(fontSize$)
			For j = 1 to count(h$[])
				gr.modify VAL(h$[j]),"text",rdbOff$
			Next
			gr.text.size VAL(fontSize$)
			Bundle.contain fieldsHandler,fldName$+setValue$,x
			if x > 0 then 
				Bundle.get fieldsHandler,fldName$+setValue$,txt
				bundle.get 1,"rdbOn",rdbOn$
				gr.modify txt,"text",rdbOn$
			Endif
		elseif type$ = "CKB" then 
			check$ = ""
			if setValue$ = "On" Then check$ = chr$(10004)
			gr.modify hText, "text", check$
		else		% texts
			txt$ = setValue$
			if txt$ = "" & (type$ <> "CMT" & type$<> "CMB") then 
				txt$ =  WORD$(elem$,5,",")	% hint
				setColor("silver")
			endif
			gr.modify hText,"text",setValue$
		Endif
		bundle.put fh_data,fldName$,setValue$		
	next
	gr.render
FN.END
FN.DEF checkData()		% data's control
	bundle.get 1, "fh_data",fh_data
	bundle.get 1, "checks",checks
	BUNDLE.KEYS fh_data, list
	LIST.SIZE list, size
	chk = 1			% error switch
	signal$ = ""
	FOR i = 1 TO size
		LIST.GET list, i, key$
		bundle.get fh_data,key$,value$
		bundle.contain checks,key$,pntr
		if pntr > 0 Then
			fieldSignal$ = ""
			bundle.get checks,key$,cntrl$
			for j = 3 to 100
				w$ = WORD$(cntrl$,j,",")
				if w$ = "" Then F_N.break
				sw.begin LOWER$(w$)
					sw.case "required"
						if value$ = "" Then 
							chk = 0
							fieldSignal$ = key$ + " required"
							F_N.break	% superseed all errors
						endif
					sw.break
					sw.case "mail"
						if match("[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}",value$) = 0 Then 
							chk = 0
							fieldSignal$ = fieldSignal$ + chr$(10) + key$ + " incorrect mail"
						endif
					sw.break
				sw.end
			next
			signal$ = signal$ + fieldSignal$
		EndIf
	Next
	if chk = 0 Then popup signal$
	FN.RTN chk
FN.END
FN.DEF match(regexpr$,f$)
	SPLIT.ALL a$[], "*" + f$+ "*", regexpr$
	array.length ll, a$[]
	if ll = 2 Then FN.RTN 1
	FN.RTN 0
FN.END
FN.DEF deMask$(s$)	% returns string array dimension
	if is_in(a$,"#") = 0 then FN.RTN s$
	as$ = ""
	For i = 1 to LEN(s$)
		if MID$(s$,i,1) <> "#" then
			as$ = as$ + MID$(s$,i,1)
		else
			n = 0
			for k = i+1 TO len(s$)
				if is_number(mid$(s$,k,1)) then 
					n = n*10 + VAL(mid$(s$,k,1))
				else 
					F_N.break
				endif
			Next
			i = k-1
			as$ = as$ + chr$(n)
		endif	
	Next
	FN.RTN as$
FN.END
FN.DEF loadBundle(bndl,a$[])
	l = count(a$[])
	FOR i = 1 To l step 2
		bundle.put bndl,a$[i],a$[i+1]
	NEXT
FN.END
FN.DEF loadBundleList(bndl,list$)
	SPLIT lst$[], list$, ","
	loadBundle(bndl,lst$[])
FN.END
FN.DEF getDefaultBundle$(bndl,key$,default$)
	Bundle.contain bndl, key$, x
	c$ = default$
	if x  > 0 Then bundle.get bndl, key$, c$
	FN.RTN c$
FN.END