FN.DEF editText(text$,left,top,style,color$)	% returns the handle to the text
	gr.text.align style
	if color$ <> "" then setColor(color$)
	gr.text.draw f1,left,top,text$
	FN.RTN f1
FN.END
FN.DEF box(left,top,width,height,color$)	% returns the box handle
	setColor(color$)
	gr.rect bx,left,top,left+width,top+height
	FN.RTN bx
FN.END
FN.DEF button(text$,left,top,width,height)	% return box
! the bacground color is external for to allow for its choice and transparency
	radius = INT(height*0.2)
	diameter = 2 * radius
	DIM aG[7]		% array of grafic items
	gr.text.align 2		% text centered
	gr.rect btn,left+radius,top,left+width-radius,top+height
	gr.group g,btn
	gr.get.value g,"list",gList	% this is the grafic tab list
	gr.rect aG[1],left,top+radius,left+radius,top+height-radius	% right rectangle
	gr.rect aG[2],left+width-radius,top+radius,left+width,top+height-radius	% left rectangle
	Gr.arc aG[3], left, top+height-diameter, left+diameter, top+height, 90, 90, 1
	Gr.arc aG[4], left, top, left+diameter, top+diameter, 180, 90, 1
	Gr.arc aG[5], left+width-diameter, top, left+width, top+diameter, 270, 90, 1 
	Gr.arc aG[6], left+width-diameter, top+height-diameter, left+width, top+height, 0, 90, 1 
	gr.Color 255,40,40,40,3
	gr.text.draw aG[7],left+0.5*width,top+0.6*height,text$
	list.add.array gList,aG[]
	FN.RTN btn
FN.END
FN.DEF decodeColor (color$,aClrs[])	% color$ = colorName[,S|F|SF|FS] (case insensitive)
	bundle.get 1, "colors", colors	% get the current color
	c$ = "255 255 255 255" 	% white unchanged stroke/fill
	aClrs[5] = -1	% fill or stroke unchanged
	SPLIT aC$[],color$,","
	ARRAY.LENGTH n, aC$[]
	if n > 1 Then
		k = is_in(UPPER$(aC$[2]),"0S1F2SF2FS")
		if k > 1 Then aClrs[5] = VAL(MID$("0S1F2SF2FS",k-1,1))
	Endif
	Bundle.contain colors, LOWER$(aC$[1]) , x
	if x > 0 Then 
		bundle.get colors,LOWER$(aC$[1]), c$
	else
		c$ = aC$[1]
	endif
	SPLIT aC$[], c$
	for i = 1 to 4
		aClrs[i] = VAL(aC$[i])
	Next
FN.END
FN.DEF setColor(color$)
	array.load aC[],0,0,0,0,0
	decodeColor(color$,aC[])
	gr.color aC[1],aC[2],aC[3],aC[4],aC[5]
FN.END
FN.DEF changeColor(obj,c1$,c2$,tp)	% obj to paint, color1, color2, time (if time = 0 no color2)
	GR.GET.VALUE obj, "paint", p  % get index of first Paint
	array.load aC[],0,0,0,0,0
	decodeColor(c1$,aC[])
	gr.color aC[1],aC[2],aC[3],aC[4],aC[5],p
	gr.render
	if tp > 0 Then
		PAUSE tp
		decodeColor(c2$,aC[])
		gr.color aC[1],aC[2],aC[3],aC[4],aC[5],p
		gr.render
	endif
FN.END
% -------------------- utilities ----------------
FN.DEF count(a$[])	% returns string array dimension
	ARRAY.LENGTH n, a$[]
	FN.RTN n
FN.END
FN.DEF setListValues(bndl,field$[])
	For j=5 To count(field$[])
		if field$[j] <> "" then
			key$ = word$(field$[j],2,":")
			if key$ = "" Then key$ = word$(field$[j],1,":")
			bundle.put bndl,field$[2] + key$,word$(field$[j],1,":")
		endif
	Next
FN.END
FN.DEF addTouch(bndl,field$,bx)
	gr.get.value bx,"left",left
	gr.get.value bx,"top",top
	gr.get.value bx,"right",right
	gr.get.value bx,"bottom",bottom
	bundle.put bndl,field$,USING$("","%d,%d,%d,%d,%d,",INT(bx),INT(left),INT(top),INT(right),INT(bottom))
FN.END